UNIT graf19;

INTERFACE

USES
 crt,dos;

CONST
 maxX=319;
 maxY=199;
 videoseg=$a000;
 aspect_ratio=0.95;

TYPE
 pixmap=FILE OF byte;
 digit=0..9;
 pistelista=^pistesolmu;
 pistesolmu=RECORD
    x,y:integer;
    next:pistelista;
   END;

VAR
 bufferseg:word;
 fontheight,fontwidth,fontsize:integer;
 fontti:pointer;

PROCEDURE inigraf;
PROCEDURE graftila;
PROCEDURE tekstitila;
PROCEDURE nayttoon;
PROCEDURE varaa_puskuri;
PROCEDURE aseta_puskuri(uusi:word);
PROCEDURE tyhjenna_puskuri;
PROCEDURE tayta_puskuri(vari:byte);
PROCEDURE ruutu;
PROCEDURE puskuriin;
FUNCTION  luepiste(x,y:integer):byte;
PROCEDURE piirrapiste(x,y:integer;vari:byte);
PROCEDURE luekuva(x1,y1,x2,y2:integer;puskuri:pointer);
PROCEDURE file2image(VAR f:file;VAR image:pointer);
PROCEDURE mov_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE and_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE xor_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE movnz_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE outchar(ch:char;x,y:integer;vari:byte);
PROCEDURE outtextXY(x,y:integer;teksti:string;vari:byte);
PROCEDURE hightextXY(x,y:integer;teksti:string;syv:integer;vari,varjovari:byte);
PROCEDURE instringXY(x,y:integer;VAR teksti:string;vari:byte);
PROCEDURE suorakaide(vyx,vyy,oax,oay:integer;vari:byte);
PROCEDURE ympyra(cx,cy,sade:integer;vari:byte);
PROCEDURE kiekko(cx,cy,sade:integer;vari:byte);
PROCEDURE xsuora(ax,ay,pituus:integer;vari:byte);
PROCEDURE ysuora(ax,ay,pituus:integer;vari:byte);
PROCEDURE kehys(vyx,vyy,oax,oay:integer;vari:byte);
PROCEDURE suora(ax,ay,lx,ly:integer;vari:byte);
PROCEDURE varjokaide(vyx,vyy,oax,oay,syv:integer;vari,varjovari:byte);
PROCEDURE led(num:digit;ax,ay:integer;vari:byte);
PROCEDURE lue_fontti(fnimi:string);
PROCEDURE aseta_fontti(VAR p:pointer;uusheight,uuswidth:integer);
PROCEDURE fill_region(x,y:integer;bckgr,col:byte);

IMPLEMENTATION

PROCEDURE graftila;
BEGIN
 asm
  mov ax, 0013h
  int 10h
 end;
END;

PROCEDURE inigraf;
BEGIN
 graftila;
 bufferseg:=$a000;
 fontti:=NIL;
END;

PROCEDURE tekstitila;
BEGIN
 asm
  mov ax, 0003h
  int 10h
 end;
END;

PROCEDURE nayttoon;
BEGIN
 bufferseg:=$a000;
END;

PROCEDURE varaa_puskuri;
VAR p:pointer;
BEGIN
 getmem(p,64016);
 bufferseg:=seg(p^)+(ofs(p^) SHR 4);
END;

PROCEDURE aseta_puskuri(uusi:word);
BEGIN
 bufferseg:=uusi;
END;

PROCEDURE tyhjenna_puskuri;
VAR target:word;
BEGIN
 target:=bufferseg;
 asm
  push es
  push di
  xor ax, ax
  mov cx, $7d00
  mov dx, target
  mov es, dx
  mov di, ax
  rep stosw
  pop di
  pop es
 end;
END;

PROCEDURE tayta_puskuri(vari:byte);
VAR target:word;color:byte;
BEGIN
 target:=bufferseg;
 color:=vari;
 asm
  push es
  push di
  xor ax, ax
  mov cx, $7d00
  mov dx, target
  mov es, dx
  mov di, ax
  mov ah, color
  mov al, ah
  rep stosw
  pop di
  pop es
 end;
END;

PROCEDURE ruutu;
BEGIN
 asm
  push es
  push ds
  push si
  push di
  xor ax, ax
  mov si, ax
  mov di, ax
  mov dx, videoseg
  mov es, dx
  mov dx, bufferseg
  mov ds, dx
  mov cx, $7d00
  rep movsw
  pop di
  pop si
  pop ds
  pop es
 end;
END;

PROCEDURE puskuriin;
BEGIN
 asm
  push es
  push ds
  push si
  push di
  xor ax, ax
  mov si, ax
  mov di, ax
  mov dx, bufferseg
  mov es, dx
  mov dx, videoseg
  mov ds, dx
  mov cx, $7d00
  rep movsw
  pop di
  pop si
  pop ds
  pop es
 end;
END;

FUNCTION luepiste(x,y:integer):byte;
VAR apux,apuy,off,target:word;
BEGIN
 apuy:=y; apux:=x;
 target:=bufferseg;
 asm
  mov bx, apuy
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, apux
  mov off, ax
 end;
 luepiste:=Mem[target:off];
END;

PROCEDURE piirrapiste(x,y:integer;vari:byte);
VAR apux,apuy,off,target:word;
BEGIN
 apuy:=y; apux:=x;
 target:=bufferseg;
 asm
  mov bx, apuy
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, apux
  mov off, ax
 end;
 Mem[target:off]:=vari;
END;

PROCEDURE luekuva(x1,y1,x2,y2:integer;puskuri:pointer);
VAR i,j,sarakemaara,rivimaara:integer; off1,off2,off3,seg2,target:word;
BEGIN
 sarakemaara:=x2-x1+1;
 target:=bufferseg;
 rivimaara:=y2-y1+1;
 off1:=ofs(puskuri^);
 i:=x1; j:=y1;
 asm
  mov bx, j
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, i
  mov off2, ax
 end;
 off3:=off1+2;
 seg2:=seg(puskuri^);
 MemW[seg2:off1]:=lo(sarakemaara);
 MemW[seg2:off1+1]:=lo(rivimaara);
 asm
   push ds
   push es
   push di
   push si
 end;
 for j:=1 to rivimaara do
 begin
  asm
   mov dx, target
   mov ds, dx
   mov di, seg2
   mov es, di
   mov di, off3
   mov si, off2
   mov cx, sarakemaara
   shr cx, 1
   rep movsw
   mov off3, di
   add off2, 320
  end;
 end;
 asm
   pop si
   pop di
   pop es
   pop ds
 end;
END;

PROCEDURE file2image(VAR f:file;VAR image:pointer);
VAR koko,koodi:integer;
BEGIN
 reset(f,1);
 koko:=filesize(f);
 getmem(image,koko+2);
 blockread(f,image^,koko,koodi);
END;

PROCEDURE mov_piirra(x1,y1:integer;puskuri:pointer);
VAR i,j,ulkona,pihalla,sarakemaara,rivimaara:integer; off1,off2,off3,seg2,target:word;
BEGIN
 off1:=ofs(puskuri^);
 target:=bufferseg;
 i:=x1; j:=y1;
 ulkona:=0;
 pihalla:=0;
 IF x1<0 THEN
 BEGIN
  i:=0;
  ulkona:=-x1;
 END;
 IF y1<0 THEN
 BEGIN
  j:=0;
  pihalla:=-y1;
 END;
 asm
  mov bx, j
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, i
  mov off2, ax
 end;
 off3:=off1+2+ulkona;
 seg2:=seg(puskuri^);
 sarakemaara:=Mem[seg2:off1];
 sarakemaara:=sarakemaara AND $fffe;
 off3:=off3+(sarakemaara*pihalla);
 IF x1+sarakemaara>320 THEN ulkona:=x1+sarakemaara-320;
 sarakemaara:=sarakemaara-ulkona;
 rivimaara:=Mem[seg2:off1+1];
 IF y1+rivimaara>200 THEN pihalla:=y1+rivimaara-200;
 rivimaara:=rivimaara-pihalla;
 asm
   push ds
   push es
   push di
   push si
 end;
 for j:=1 to rivimaara do
 begin
  asm
   mov dx, seg2
   mov ds, dx
   mov di, target
   mov es, di
   mov di, off2
   mov si, off3
   mov cx, sarakemaara
   shr cx, 1
   rep movsw
   mov ax, si
   add ax, ulkona
   mov off3, ax
   add off2, 320
  end;
 end;
 asm
   pop si
   pop di
   pop es
   pop ds
 end;
END;

PROCEDURE and_piirra(x1,y1:integer;puskuri:pointer);
VAR i,j,ulkona,pihalla,sarakemaara,rivimaara:integer; off1,off2,off3,seg2,target:word;
BEGIN
 off1:=ofs(puskuri^);
 i:=x1; j:=y1; ulkona:=0; pihalla:=0;
 IF i<0 THEN
 BEGIN
  ulkona:=-i;
  i:=0;
 END;
 IF j<0 THEN
 BEGIN
  pihalla:=-j;
  j:=0;
 END;
 target:=bufferseg;
 asm
  mov bx, j
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, i
  mov off2, ax
 end;
 off3:=off1+2+ulkona;
 seg2:=seg(puskuri^);
 sarakemaara:=Mem[seg2:off1];
 sarakemaara:=sarakemaara AND $fffe;
 off3:=off3+(sarakemaara*pihalla);
 IF sarakemaara+x1>320 THEN ulkona:=sarakemaara+x1-320;
 sarakemaara:=sarakemaara-ulkona;
 rivimaara:=Mem[seg2:off1+1];
 IF rivimaara+y1>200 THEN pihalla:=rivimaara+y1-200;
 rivimaara:=rivimaara-pihalla;
 asm
   push ds
   push es
   push di
   push si
 end;
 for j:=1 to rivimaara do
 begin
  asm
   mov dx, seg2
   mov ds, dx
   mov di, target
   mov es, di
   mov di, off2
   mov si, off3
   mov cx, sarakemaara
   shr cx, 1
  @riviluuppi:
   mov ax, [ds:si]
   and [es:di], ax
   inc si
   inc si
   inc di
   inc di
   loop @riviluuppi
   mov ax, si
   add ax, ulkona
   mov off3, ax
   add off2, 320
  end;
 end;
 asm
   pop si
   pop di
   pop es
   pop ds
 end;
END;

PROCEDURE xor_piirra(x1,y1:integer;puskuri:pointer);
VAR i,j,sarakemaara,rivimaara,ulkona,pihalla:integer; off1,off2,off3,seg2,target:word;
BEGIN
 off1:=ofs(puskuri^);
 i:=x1; j:=y1; ulkona:=0; pihalla:=0;
 target:=bufferseg;
 IF i<0 THEN
 BEGIN
  ulkona:=-i;
  i:=0;
 END;
 IF j<0 THEN
 BEGIN
  pihalla:=-j;
  j:=0;
 END;
 asm
  mov bx, j
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, i
  mov off2, ax
 end;
 off3:=off1+2+ulkona;
 seg2:=seg(puskuri^);
 sarakemaara:=Mem[seg2:off1];
 sarakemaara:=sarakemaara AND $fffe;
 off3:=off3+(sarakemaara*pihalla);
 IF x1+sarakemaara>320 THEN ulkona:=sarakemaara+x1-320;
 sarakemaara:=sarakemaara-ulkona;
 rivimaara:=Mem[seg2:off1+1];
 IF y1+rivimaara>200 THEN pihalla:=rivimaara+y1-200;
 rivimaara:=rivimaara-pihalla;
 asm
   push ds
   push es
   push di
   push si
 end;
 for j:=1 to rivimaara do
 begin
  asm
   mov dx, seg2
   mov ds, dx
   mov di, target
   mov es, di
   mov di, off2
   mov si, off3
   mov cx, sarakemaara
   shr cx, 1
  @riviluuppi:
   mov ax, [ds:si]
   xor [es:di], ax
   inc si
   inc si
   inc di
   inc di
   loop @riviluuppi
   mov ax, si
   add ax, ulkona
   mov off3, ax
   add off2, 320
  end;
 end;
 asm
   pop si
   pop di
   pop es
   pop ds
 end;
END;

PROCEDURE movnz_piirra(x1,y1:integer;puskuri:pointer);
VAR i,j,sarakemaara,rivimaara,ulkona,pihalla:integer;
    off1,off2,off3,seg2,target:word; odd:boolean;
BEGIN
 off1:=ofs(puskuri^);
 i:=x1; j:=y1; ulkona:=0; pihalla:=0;
 target:=bufferseg;
 IF i<0 THEN
 BEGIN
  ulkona:=-i;
  i:=0;
 END;
 IF j<0 THEN
 BEGIN
  pihalla:=-j;
  j:=0;
 END;
 asm
  mov bx, j
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, i
  mov off2, ax
 end;
 off3:=off1+2+ulkona;
 seg2:=seg(puskuri^);
 sarakemaara:=Mem[seg2:off1];
 sarakemaara:=sarakemaara AND $fffe;
 off3:=off3+(sarakemaara*pihalla);
 IF x1+sarakemaara>320 THEN ulkona:=sarakemaara+x1-320;
 sarakemaara:=sarakemaara-ulkona;
 rivimaara:=Mem[seg2:off1+1];
 IF y1+rivimaara>200 THEN pihalla:=rivimaara+y1-200;
 rivimaara:=rivimaara-pihalla;
 asm
   push ds
   push es
   push di
   push si
 end;
 for j:=1 to rivimaara do
 begin
  asm
   mov dx, seg2
   mov ds, dx
   mov di, target
   mov es, di
   mov di, off2
   mov si, off3
   mov cx, sarakemaara
   shr cx, 1
  @riviluuppi:
   mov ax, [ds:si]
   and al, al
   jz @ohi1
   mov [es:di], al
  @ohi1:
   inc di
   and ah, ah
   jz @ohi2
   mov [es:di], ah
  @ohi2:
   inc si
   inc si
   inc di
   loop @riviluuppi
   mov ax, si
   add ax, ulkona
   mov off3, ax
   add off2, 320
  end;
 end;
 asm
   pop si
   pop di
   pop es
   pop ds
 end;
END;

PROCEDURE outchar(ch:char;x,y:integer;vari:byte);
VAR poikkeutus,fontseg,fontoff,target:word;i:integer;col,apu:byte;
BEGIN
 poikkeutus:=320*y+x;
 col:=vari;
 target:=bufferseg;
 fontseg:=seg(fontti^);
 fontoff:=ofs(fontti^)+fontsize*ord(ch);
 FOR i:=1 TO fontwidth DO
 BEGIN
  asm
   push es
   push dx
   mov dx, fontseg
   mov es, dx
   mov bx, fontoff
   mov ah, [es:bx]
   mov cx, fontheight
   cmp cx, $0008
   je @vain8
   inc bx
   mov al, [es:bx]
   mov fontoff, bx
   @vain8:
   mov dx, target
   mov es, dx
   mov bx, poikkeutus
   mov dl, col
   @pixeliluuppi:
   shl ax, 1
   jnc @ohi
   mov [es:bx], dl
   @ohi:
   add bx, 320
   loop @pixeliluuppi
  end;
  inc(poikkeutus);
  inc(fontoff);
 END;
END;

PROCEDURE outtextXY(x,y:integer;teksti:string; vari:byte);
VAR paikkax,paikkay,i,pituus,raja:integer;
BEGIN
 paikkax:=x; paikkay:=y;
 i:=1; pituus:=Length(teksti); raja:=maxX-fontwidth+1;
 WHILE (i<=pituus) AND (paikkax<=raja) DO
 BEGIN
  outchar(teksti[i],paikkax,paikkay,vari);
  paikkax:=paikkax+fontwidth+1;
  i:=i+1;
 END;
END;

PROCEDURE hightextXY(x,y:integer;teksti:string;syv:integer;vari,varjovari:byte);     
VAR i:integer;
BEGIN
 FOR i:=syv DOWNTO 1 DO
  outtextXY(x+i,y,teksti,varjovari);
 outtextXY(x,y,teksti,vari);
END;

PROCEDURE instringXY(x,y:integer;VAR teksti:string;vari:byte);
VAR dummy:char; i,pituus,paikkax,paikkay:integer; pohjavari:byte;
BEGIN
 teksti:='';
 pohjavari:=luepiste(x,y);
 paikkax:=x; paikkay:=y;
 pituus:=0;
 REPEAT
  REPEAT
   outchar('_',paikkax,paikkay,vari);
   dummy:=readkey;
   outchar(chr(178),paikkax,paikkay,pohjavari);
  UNTIL ord(dummy)<>0;
  CASE dummy OF
  chr(13),chr(10):BEGIN END;
  chr(27):BEGIN
           FOR i:=pituus DOWNTO 1 do
           BEGIN
            paikkax:=paikkax-fontwidth-1;
            outchar(chr(178),paikkax,paikkay,pohjavari);
           END;
           teksti:='';
           paikkax:=x;
           pituus:=0;
          END;
  chr(8):IF pituus>0 THEN
         BEGIN
          paikkax:=paikkax-fontwidth-1;
          outchar(chr(178),paikkax,paikkay,pohjavari);
          delete(teksti,pituus,1);
          pituus:=pituus-1;
         END;
  ELSE BEGIN
        outchar(dummy,paikkax,paikkay,vari);
        teksti:=teksti+dummy;
        paikkax:=paikkax+fontwidth+1;
        pituus:=pituus+1;
       END;
  END;
 UNTIL dummy=chr(13);
END;

PROCEDURE xsuora(ax,ay,pituus:integer;vari:byte);
VAR l:integer;off,target:word;col:byte;
BEGIN
 l:=pituus;
 IF ax<0 THEN BEGIN l:=l+ax; ax:=0 END;
 IF (l>0) AND (ax<320) AND (ay>=0) AND (ay<200) THEN
 BEGIN
 target:=bufferseg;
 off:=320*ay+ax;
 IF l+ax>320 THEN l:=320-ax;
 col:=vari;
 asm
  push es
  push dx
  mov dx, target
  mov es, dx
  mov dx, off
  mov di, dx
  mov cx, l
  mov al, col
  rep stosb
  pop dx
  pop es
 end;
 END;
END;

PROCEDURE ysuora(ax,ay,pituus:integer;vari:byte);
VAR l:integer;off,target:word;col:byte;
BEGIN
 l:=pituus;
 IF ay<0 THEN BEGIN l:=l+ay; ay:=0 END;
 IF (ax>=0) AND (ax<320) AND (l>0) AND (ay<200) THEN
 BEGIN
 off:=320*ay+ax;
 target:=bufferseg;
 IF l+ay>200 THEN l:=200-ay;
 col:=vari;
 asm
  push es
  mov dx, target
  mov es, dx
  mov dx, off
  mov di, dx
  mov al, col
  mov bx, $0140
  mov cx, l
 @luuppi:
  mov [es:di], al
  add di, bx
  loop @luuppi
  pop es
 end;
 END;
END;

PROCEDURE kehys(vyx,vyy,oax,oay:integer;vari:byte);
VAR xpit,ypit:integer;
BEGIN
 xpit:=oax+1-vyx;
 ypit:=oay+1-vyy;
 xsuora(vyx,vyy,xpit,vari);
 xsuora(vyx,oay,xpit,vari);
 ysuora(vyx,vyy,ypit,vari);
 ysuora(oax,vyy,ypit,vari);
END;

PROCEDURE suorakaide(vyx,vyy,oax,oay:integer;vari:byte);
VAR target,off,korkeus,l:word;col:byte;
BEGIN
 korkeus:=oay+1-vyy;
 l:=oax+1-vyx;
 target:=bufferseg;
 off:=320*vyy+vyx;
 col:=vari;
 asm
  push es
  mov dx, target
  mov es, dx
  mov al, col
  mov dx, off
  push dx
  mov bx, $0140
  mov cx, korkeus
 @luuppi:
  mov di, dx
  push cx
  mov cx, l
  rep stosb
  pop cx
  pop dx
  add dx, bx
  push dx
  loop @luuppi
  pop dx
  pop es
 end;
END;

PROCEDURE x_line(ax,ay,lx,ly:integer;vari:byte);
{* ax < lx ja kulmakerroin in [-1,1] *}
VAR target,off1,off2:word;incr:byte;kk,pituus:integer;
    sx,sy:real;
BEGIN
 target:=bufferseg;
 off1:=(320*ay+ax);
 pituus:=lx-ax;
 sx:=pituus;
 sy:=ly-ay;
 kk:=round(sy*256/sx);
 IF kk>=0 THEN
 BEGIN
  IF kk>255 THEN kk:=255;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add bl, dl
   jnc @ohi
   add di, 0140h
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
 IF kk<0 THEN
 BEGIN
  IF kk<-255 THEN kk:=-255;
  kk:=-kk;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add bl, dl
   jnc @ohi
   sub di, 0140h
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
END;

PROCEDURE y_line(ax,ay,lx,ly:integer;vari:byte);
{* ay < ly ja kulmakerroin not in [-1,1] *}
VAR target,off1,off2:word;incr:byte;kk,pituus:integer;
    sx,sy:real;
BEGIN
 target:=bufferseg;
 off1:=(320*ay+ax);
 pituus:=ly-ay;
 sy:=pituus;
 sx:=lx-ax;
 kk:=round(sx*256/sy);
 IF kk>=0 THEN
 BEGIN
  IF kk>255 THEN kk:=255;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add di, 013fh
   add bl, dl
   jnc @ohi
   inc di
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
 IF kk<0 THEN
 BEGIN
  IF kk<-255 THEN kk:=-255;
  kk:=-kk;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add di, 013fh
   add bl, dl
   jnc @ohi
   dec di
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
END;

PROCEDURE suora(ax,ay,lx,ly:integer;vari:byte);
VAR bx,by,i,pituus,sx,sy:integer;
 x,y,min,max,k,b:real;
BEGIN
 sx:=lx-ax;
 sy:=ly-ay;
 IF sx=0 THEN
 BEGIN
  IF ly<ay THEN
  BEGIN
   bx:=ax;ax:=lx;lx:=bx;
   by:=ay;ay:=ly;ly:=by;
  END;
  ysuora(ax,ay,ly-ay+1,vari)
 END
 ELSE IF sy=0 THEN
 BEGIN
  IF lx<ax THEN
  BEGIN
   bx:=ax;ax:=lx;lx:=bx;
   by:=ay;ay:=ly;ly:=by;
  END;
  xsuora(ax,ay,lx-ax+1,vari);
 END
 ELSE
 BEGIN
  k:=sy/sx;
  b:=ay-k*ax;
  IF sx<0 THEN
  BEGIN
   bx:=ax;ax:=lx;lx:=bx;
   by:=ay;ay:=ly;ly:=by;
  END;
  IF ax<0 THEN
  BEGIN
   ax:=0; ay:=round(b);
  END;
  IF lx>319 THEN
  BEGIN
   lx:=319; ly:=round(k*lx+b);
  END;
  min:=ay; max:=ay;
  IF ay<ly THEN max:=ly ELSE min:=ly;
  IF (ax<lx) AND (max>0) AND (min<199) THEN
  BEGIN
   IF ay<0 THEN
   BEGIN
    ay:=0; ax:=round(-b/k);
   END;
   IF ly<0 THEN
   BEGIN
    ly:=0; lx:=round(-b/k);
   END;
   IF ay>199 THEN
   BEGIN
    ay:=199; ax:=round((199-b)/k);
   END;
   IF ly>199 THEN
   BEGIN
    ly:=199; lx:=round((199-b)/k);
   END;
   sx:=lx-ax;
   sy:=ly-ay;
   pituus:=abs(sx)+abs(sy);
   IF pituus>0 THEN
   BEGIN
    IF abs(sx)>=abs(sy) THEN x_line(ax,ay,lx,ly,vari)
    ELSE
    BEGIN
     IF ly<ay THEN
     BEGIN
      bx:=ax;ax:=lx;lx:=bx;
      by:=ay;ay:=ly;ly:=by;
     END;
     y_line(ax,ay,lx,ly,vari)
    END;
   END;
  END;
 END;
END;

PROCEDURE ympyra(cx,cy,sade:integer;vari:byte);
VAR i,x,y,pituus:integer;kulma,askel:real;
BEGIN
 pituus:=8*sade;
 askel:=6.283/pituus;
 kulma:=0.0;
 FOR i:=0 TO pituus DO
 BEGIN
  x:=cx+round(sade*cos(kulma));
  y:=cy+round(sade*sin(kulma)*aspect_ratio);
  kulma:=kulma+askel;
  piirrapiste(x,y,vari);
 END;
END;

PROCEDURE kiekko(cx,cy,sade:integer;vari:byte);
VAR x,y:real;i,j,korkeus,pituus:integer;
BEGIN
 korkeus:=round(sade*aspect_ratio);
 FOR i:=cy-korkeus TO cy+korkeus DO
 BEGIN
  y:=(i-cy)/aspect_ratio;
  x:=sade*sade-y*y;
  IF x>0.0 THEN
  BEGIN
   x:=sqrt(x);
   j:=round(x+0.2); pituus:=2*j+1;
   xsuora(cx-j,i,pituus,vari);
  END;
 END;
END;

PROCEDURE led(num:digit;ax,ay:integer;vari:byte);
VAR
 paalla:ARRAY [1..7] OF boolean;i:integer;
BEGIN
 IF num IN [1,7] THEN
  FOR i:=1 TO 7 DO paalla[i]:=false
 ELSE
  FOR i:=1 TO 7 DO paalla[i]:=true;
 CASE num OF
 0:paalla[4]:=false;
 1:begin paalla[3]:=true; paalla[6]:=true; end;
 2:begin paalla[2]:=false; paalla[6]:=false; end;
 3:begin paalla[2]:=false; paalla[5]:=false; end;
 4:begin paalla[1]:=false; paalla[5]:=false; paalla[7]:=false; end;
 5:begin paalla[3]:=false; paalla[5]:=false; end;
 6:paalla[3]:=false;
 7:begin paalla[1]:=true; paalla[3]:=true; paalla[6]:=true end;
 9:paalla[5]:=false;
 END;
 FOR i:=1 TO 7 DO
 IF paalla[i] THEN
 BEGIN
  CASE i OF
  1:xsuora(ax,ay,8,vari);
  2:ysuora(ax,ay,8,vari);
  3:ysuora(ax+7,ay,8,vari);
  4:xsuora(ax,ay+7,8,vari);
  5:ysuora(ax,ay+8,8,vari);
  6:ysuora(ax+7,ay+8,8,vari);
  7:xsuora(ax,ay+15,8,vari);
  END;
 END;
END;

PROCEDURE lue_fontti(fnimi:string);
VAR f:FILE; maara,koodi:integer; apu:byte;
BEGIN
 assign(f, fnimi+'.fon');
 reset(f,1);
 blockread(f,apu,1,koodi);
 fontwidth:=apu;
 blockread(f,apu,1,koodi);
 fontheight:=apu;
 fontsize:=fontwidth*(fontheight SHR 3);
 maara:=(fontsize SHL 8);
 getmem(fontti,maara);
 blockread(f,fontti^,maara,koodi);
END;

PROCEDURE aseta_fontti(VAR p:pointer;uusheight,uuswidth:integer);
BEGIN
 fontti:=p;
 fontheight:=uusheight;
 fontwidth:=uuswidth;
 fontsize:=fontwidth*(fontheight SHR 3);
END;

PROCEDURE varjokaide(vyx,vyy,oax,oay,syv:integer;vari,varjovari:byte);    
VAR i:integer;
BEGIN
 FOR i:=1 TO syv DO
  kehys(vyx+i,vyy+i,oax+i,oay+i,varjovari);
 suorakaide(vyx,vyy,oax,oay,vari);
END;

PROCEDURE fill_region(x,y:integer;bckgr,col:byte);
VAR pl1,pl2:pistelista;curx,cury:integer;uusi:boolean;
BEGIN
 new(pl1);
 pl1^.next:=NIL;
 pl1^.x:=x;
 pl1^.y:=y;
 IF (x>=0) AND (x<320) AND (y>=0) AND (y<200) THEN
 WHILE pl1<>NIL DO
 BEGIN
  curx:=pl1^.x;
  cury:=pl1^.y;
  piirrapiste(curx,cury,col);
  uusi:=false;
  IF (cury>0) AND (luepiste(curx,cury-1)=bckgr) THEN
  BEGIN
   uusi:=true;
   dec(cury);
  END
  ELSE
   IF (curx<319) AND (luepiste(curx+1,cury)=bckgr) THEN
   BEGIN
    uusi:=true;
    inc(curx);
   END
   ELSE
    IF (cury<199) AND (luepiste(curx,cury+1)=bckgr) THEN
    BEGIN
     uusi:=true;
     inc(cury);
    END
    ELSE
     IF (curx>0) AND (luepiste(curx-1,cury)=bckgr) THEN
     BEGIN
      uusi:=true;
      dec(curx);
     END;
  IF uusi THEN
  BEGIN
   new(pl2);
   pl2^.x:=curx;
   pl2^.y:=cury;
   pl2^.next:=pl1;
   pl1:=pl2;
  END
  ELSE
  BEGIN
   pl2:=pl1;
   pl1:=pl1^.next;
   dispose(pl2);
  END;
 END;
END;

BEGIN
END.
