program master_mind;

uses crt,dos,graf19,hiiri;

type
 vari=(musta,ruskea,valkoinen,punainen,oranssi,keltainen,vihrea,sininen,tyhja);
 nappula=musta..sininen;
 kaikki=array [nappula,nappula,nappula,nappula,nappula] of boolean;
 viisari=^kaikki;
 indeksi=1..5;
 rivi=array [indeksi] of vari;
 rividata=record
           arvaus:rivi;
           oikein,vaarin:integer;
          end;
 taulu=array [1..12] of rividata;

const
 kirjo:array [vari] of byte =($10,$06,$1e,$28,$2a,$2c,$2f,$20,$17);
 kiilto:array [vari] of byte =($14,$2a,$1f,$3f,$2b,$5c,$5f,$38,$17);

var
 hidden,current:rivi;
 game:taulu;
 hiirix,hiiriy,numero:integer;
 maara:0..65535;
 dummy:char;
 ratkesi,loppu:boolean;
 all:viisari;

function ord2vari(i:integer):vari;
var j:integer; apu:vari;
begin
 apu:=musta;
 for j:=1 to i do
  apu:=succ(apu);
 ord2vari:=apu;
end;

function arvo:vari;
var i,j:integer; apu:vari;
begin
 i:=random(8);
 apu:=musta;
 for j:=1 to i do
  apu:=succ(apu);
 arvo:=apu;
end;

function valmis:boolean;
var apu:boolean; i:integer;
begin
 apu:=true;
 for i:=1 to 5 do
  if current[i]=tyhja then apu:=false;
 valmis:=apu;
end;

procedure evaluointi(VAR arv:rividata; r:rivi);
var jaljella,rjaljella: array[1..5] of boolean; i,j:integer;
begin
 for i:=1 to 5 do
 begin
  jaljella[i]:=true;
  rjaljella[i]:=true;
 end;
 arv.oikein:=0;
 arv.vaarin:=0;
 for i:=1 to 5 do
 if arv.arvaus[i]=r[i] then
 begin
  inc(arv.oikein);
  jaljella[i]:=false;
  rjaljella[i]:=false;
 end;
 for i:=1 to 5 do
 for j:=1 to 5 do
 if jaljella[i] and rjaljella[j] and (arv.arvaus[i]=r[j]) then
 begin
  inc(arv.vaarin);
  jaljella[i]:=false;
  rjaljella[j]:=false;
 end;
end;

procedure ruudukko;
var i:integer;
begin
 suorakaide(60,2,145,194,$17);
 for i:=0 to 5 do
  ysuora(59+17*i,2,192,$68);
 for i:=1 to 13 do
  xsuora(59,210-16*i,86,$68);
 for i:=1 to 13 do
  xsuora(60,211-16*i,86,$64);
 for i:=0 to 5 do
  ysuora(60+17*i,3,192,$64);
end;

procedure paletti;
var c:vari;y:integer;
begin
 for c:=musta to tyhja do
 begin
  y:=12+20*ord(c);
  kehys(161,y-1,177,y+15,$68);
  suorakaide(162,y,178,y+16,kirjo[c]);
  kehys(162,y,178,y+16,$64);
 end;
 outchar('P',168,y+5,$2f);
end;

procedure piirra_nappula(v:vari;i,j:integer);
var x,y:integer;
begin
 x:=51+17*j;
 y:=203-16*i;
 piilotahiiri;
 kiekko(x,y,6,kirjo[v]);
 piirrapiste(x+1,y+4,kiilto[v]);
 piirrapiste(x+2,y+4,kiilto[v]);
 piirrapiste(x+3,y+3,kiilto[v]);
 piirrapiste(x+4,y+2,kiilto[v]);
 piirrapiste(x+4,y+1,kiilto[v]);
 naytahiiri;
end;

procedure tyhjenna;
var i:integer;
begin
 for i:=1 to 5 do
 begin
  current[i]:=tyhja;
  piirra_nappula(tyhja,numero,i);
 end;
end;

procedure nappi(teksti:string;x,y:integer);
begin
 kehys(x-1,y-1,x+79,y+29,$68);
 suorakaide(x,y,x+80,y+30,$19);
 kehys(x,y,x+80,y+30,$64);
 outtextXY(x+41-3*length(teksti),y+11,teksti,$2f);
end;

procedure alustus;
var i:integer; v1,v2,v3,v4,v5:vari;
begin
 maara:=32768;
 for v1:=musta to sininen do
 for v2:=musta to sininen do
 for v3:=musta to sininen do
 for v4:=musta to sininen do
 for v5:=musta to sininen do
  all^[v1,v2,v3,v4,v5]:=true;
 for i:=1 to 5 do
 begin
  hidden[i]:=arvo;
  current[i]:=tyhja;
 end;
 numero:=1;
 loppu:=false;
 ratkesi:=false;
 tayta_puskuri($18);
 ruudukko;
 paletti;
 nappi('NEW GAME',220,5);
 nappi('FLUSH',220,45);
 nappi('EVALUATE',220,85);
 nappi('HINT',220,125);
 nappi('QUIT',220,165);
end;

procedure uusi_nappula(var r:rivi;v:vari);
var x,y,i:integer;
begin
 repeat until NOT vasennappi;
 lueXY(x,y);
 x:=(x shr 1);
 if (((210-y) shr 4) = numero) and (x>60) and (x<146) then
 begin
  i:=(x-44) div 17;
  if v<>tyhja then
  begin
   r[i]:=v;
   piirra_nappula(v,numero,i);
  end;
 end
 else
 if ((v<>tyhja) or (numero>1)) and (x>160) and (x<180) then
 begin
  i:=0;
  repeat
   inc(i);
  until (i>5) or (r[i]=tyhja);
  if i<=5 then
  begin
   if v=tyhja then v:=game[numero-1].arvaus[i];
   r[i]:=v;
   piirra_nappula(v,numero,i);
  end;
 end;
end;

procedure tsekkaa;
var r:rividata; v1,v2,v3,v4,v5:vari;
begin
 maara:=0;
 for v1:=musta to sininen do
 for v2:=musta to sininen do
 for v3:=musta to sininen do
 for v4:=musta to sininen do
 for v5:=musta to sininen do
 if all^[v1,v2,v3,v4,v5] then
 begin
  r.arvaus[1]:=v1;
  r.arvaus[2]:=v2;
  r.arvaus[3]:=v3;
  r.arvaus[4]:=v4;
  r.arvaus[5]:=v5;
  r.oikein:=0;
  r.vaarin:=0;
  evaluointi(r,game[numero].arvaus);
  if (r.oikein=game[numero].oikein) and (r.vaarin=game[numero].vaarin) then
   inc(maara)
  else all^[v1,v2,v3,v4,v5]:=false;
 end;
end;

function maksimi:integer;
var r:rividata; v1,v2,v3,v4,v5:vari; i,j,max:integer;
    jaljella:array[0..5,0..5] of integer;
begin
 for i:=0 to 5 do
  for j:=0 to 5 do
  jaljella[i,j]:=0;
 for v1:=musta to sininen do
 for v2:=musta to sininen do
 for v3:=musta to sininen do
 for v4:=musta to sininen do
 for v5:=musta to sininen do
 if all^[v1,v2,v3,v4,v5] then
 begin
  r.arvaus[1]:=v1;
  r.arvaus[2]:=v2;
  r.arvaus[3]:=v3;
  r.arvaus[4]:=v4;
  r.arvaus[5]:=v5;
  r.oikein:=0;
  r.vaarin:=0;
  evaluointi(r,current);
  inc(jaljella[r.oikein,r.vaarin]);
 end;
 max:=0;
 for i:=0 to 5 do
  for j:=0 to 5 do
  if jaljella[i,j]>max then max:=jaljella[i,j];
 maksimi:=max;
end;

procedure piirra_peg(valkea:boolean;i,j:integer);
var x,y:integer;
begin
 x:=10*i;
 y:=202-16*j;
 kiekko(x,y,3,$16);
 if valkea then kiekko(x+1,y+1,3,$1f)
 else kiekko(x+1,y+1,3,$10);
end;

procedure arvioi;
var i:integer;
begin
 if valmis then
 begin
  for i:=1 to 5 do
   game[numero].arvaus[i]:=current[i];
  evaluointi(game[numero],hidden);
  for i:=1 to 5 do
   current[i]:=tyhja;
  piilotahiiri;
  for i:=1 to game[numero].oikein do
   piirra_peg(true,i,numero);
  for i:=game[numero].oikein+1 to game[numero].oikein+game[numero].vaarin do
   piirra_peg(false,i,numero);
  tsekkaa;
  naytahiiri;
  inc(numero);
 end;
end;

procedure nayta;
var apu:string;
begin
 str(maara:5,apu);
 outtextXY(2,2,apu,$64);
 repeat until not vasennappi;
 suorakaide(2,2,32,10,$18);
end;

procedure kopioi;
var i,j:integer; v:vari;
begin
 i:=(hiirix-44) div 17;
 j:=(208-hiiriy) shr 4;
 if (j<numero) and (j>=1) then v:=game[j].arvaus[i]
 else v:=game[numero-1].arvaus[i];
 current[i]:=v;
 piirra_nappula(v,numero,i);
end;

procedure vihje;
var r:rivi;v1,v2,v3,v4,v5:vari; loytyi:boolean; raja,i:integer;
begin
 loytyi:=false;
 raja:=random(maara);
 for v1:=musta to sininen do
 for v2:=musta to sininen do
 for v3:=musta to sininen do
 for v4:=musta to sininen do
 for v5:=musta to sininen do
  if not loytyi then
   if all^[v1,v2,v3,v4,v5] then
   begin
    if raja=0 then
    begin
     loytyi:=true;
     r[1]:=v1;
     r[2]:=v2;
     r[3]:=v3;
     r[4]:=v4;
     r[5]:=v5;
    end
    else dec(raja);
   end;
 piilotahiiri;
 for i:=1 to 5 do
  piirra_nappula(r[i],numero,i);
 delay(2000);
 for i:=1 to 5 do
  piirra_nappula(current[i],numero,i);
 naytahiiri;
end;

procedure poista;
var i:integer;
begin
 i:=(hiirix-44) DIV 17;
 current[i]:=tyhja;
 piirra_nappula(tyhja,numero,i);
end;

procedure nayta_max;
var apu:string;
begin
 if valmis then
 begin
  str(maksimi:5,apu);
  outtextXY(2,2,apu,$68);
  repeat until not oikeanappi;
  suorakaide(2,2,32,10,$18);
 end;
end;

begin
 randomize;
 new(all);
 if not ajurion then
 begin
  writeln('No mouse detected');
  halt(1);
 end;
 inigraf;
 lue_fontti('5x8');
 piilotahiiri;
 alustus;
 naytahiiri;
 asetaXrajat(122,600);
 asetaYrajat(5,195);
 asetaXY(320,100);
 repeat
  naytahiiri;
  repeat until vasennappi or oikeanappi;
  lueXY(hiirix,hiiriy);
  hiirix:=(hiirix SHR 1);
  if vasennappi then
  begin
  if (hiirix<146) and (numero>1) then kopioi;
  if (hiirix>160) and (hiirix<180) then
   if (hiiriy>9) and (hiiriy<190) then uusi_nappula(current,ord2vari((hiiriy-10) DIV 20));
  if (hiirix>180) and (hiirix<220) then nayta;
  if (hiirix>220) then
  begin
   if (hiiriy>165) and (hiiriy<195) then loppu:=true;
   if (hiiriy>85) and (hiiriy<115) then arvioi;
   if (hiiriy>5) and (hiiriy<35) then alustus;
   if (hiiriy>45) and (hiiriy<75) then tyhjenna;
   if (hiiriy>125) and (hiiriy<155) then vihje;
   repeat until NOT vasennappi;
  end;
  end
  else
  begin
   if (hiirix<146) then poista
   else nayta_max;
   repeat until NOT oikeanappi;
  end;
 until loppu;
 tekstitila;
end.
